<template>
  <div class="card">
    <div class="card-header">
      <h1 class="card-text">Heroes y Villanos Editar</h1>
    </div>
    <div class="card-body">
      <div class="row justify-content-center">
        <div class="col-12 col-md-6">
          <FormHeroe v-if="Object.keys(heroe).length > 0" :heroe="heroe" />
          <h3 class="text-center" v-else><i class="fas fa-spinner fa-spin"></i> Cargando...</h3>
        </div>
      </div>
    </div>
    {{heroe.length}}
  </div>
</template>

<script>
import FormHeroe from '@/components/FormHeroe.vue'
import { mapState } from 'vuex'

export default {
  components: {
    FormHeroe
  },
  data() {
    return {
      heroe: {},
      loading: false
    }
  },
  mounted() {
    this.getHeroe(this.$route.params.codigo)
  },
  methods: {
    getHeroe(codigo) {
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
      this.axios.get(`/v1/heroes/${codigo}/edit`, config)
        .then(result => {
          let data = result.data.body.heroe
          this.heroe = {
            codigo: data.codigo,
            nombre: data.nombre,
            alias: data.alias,
            especialidad: data.especialidad,
            codigo: data.codigo,
            ocupacion: data.ocupacion_id,
            genero: data.genero_id
          }
        })
        .catch(e => {
          Toast.fire({
            icon: 'error',
            title: e.response.data.message
          })
          setTimeout(() => {
            this.$router.push({name: 'Heroes'})
          }, 3000);
        })
    }
  },
  computed: {
    ...mapState('usuario', ['usuario', 'token'])
  }
}
</script>
